Index: /vtcross/trunk/src/include/vtcross/components.h
===================================================================
--- /vtcross/trunk/src/include/vtcross/components.h	(revision 411)
+++ /vtcross/trunk/src/include/vtcross/components.h	(revision 431)
@@ -65,8 +65,4 @@
         virtual void SendComponentType() = 0;
 
-        /* Wait for a command signal containing task instructions.
-         */
-        //virtual void WaitForSignal() = 0;
-
         /* Completely shutdown the radio and all operations.
          */
@@ -102,4 +98,8 @@
         virtual void ConnectToRemoteComponent(const char* serverName, \
                 const char* serverPort, const bool SML) = 0;
+        
+        /* Wait for a command signal containing task instructions.
+         */
+        virtual void WaitForSignal() = 0;
 
         /* Register or deregister services that this engine provides with the
@@ -124,11 +124,11 @@
          * shell with the passed hostname and port.
          */
-        ServiceManagementLayer(const char* SML_Config, const char* serverName, const char* serverPort, int16_t clientPort);
+        ServiceManagementLayer(const char* SML_Config, const char* serverName, \
+                const char* serverPort, int16_t clientPort);
 
         /* Connect and register with the shell component at the passed hostname
          * and port.
          */
-        void ConnectToShell(const char* serverName, \
-                const char* serverPort);
+        void ConnectToShell(const char* serverName, const char* serverPort);
         void SendComponentType();
         void MessageHandler(int32_t ID);
@@ -157,5 +157,5 @@
          */
         void ReceiveServices(int32_t ID);
- 	void DeregisterServices(int32_t ID);
+ 	    void DeregisterServices(int32_t ID);
 
         /* Change the active mission of the radio to a new one and adjust radio
@@ -164,6 +164,8 @@
         void SetActiveMission();
 
-	void RegisterCognitiveEngine(int32_t ID);
-	void DeregisterCognitiveEngine(int32_t ID);
+        /* TODO
+         */
+	    void RegisterCognitiveEngine(int32_t ID);
+	    void DeregisterCognitiveEngine(int32_t ID);
 
         /* List all services provided to the radio by registered components.
@@ -176,12 +178,13 @@
         void LoadConfiguration(const char *SML_Config, Mission* &mList);
 
-	/* Create and initialize the DB to hold the services
-	 */
-	void CreateServicesDB();
-	void CreateDataDB();
-
-	void PerformActiveMission();
-	void TransactData(int32_t sourceID);
-
+	    /* Create and initialize the DB to hold the services
+	    */
+	    void CreateServicesDB();
+	    void CreateDataDB();
+
+        /* TODO
+         */
+	    void PerformActiveMission();
+	    void TransactData(int32_t sourceID);
 
         /* The socket file descriptor information for the shell which this SML
@@ -189,14 +192,16 @@
          */
         int32_t shellSocketFD;
-	CE_Reg *CE_List;
+
+        /* TODO
+         */
+	    int16_t CEPort;
+        int16_t SMLport;
+	    uint16_t numberOfCognitiveEngines;
     	int32_t cogEngSrv;
-	int16_t CEPort;
-	uint16_t numberOfCognitiveEngines;
-	uint32_t Current_ID; 
+        int32_t activeMission;
+	    uint32_t Current_ID; 
+	    bool CE_Present;
+	    CE_Reg *CE_List;
         Mission *miss;
-	bool CE_Present;
-        int32_t activeMission;
-
-        int16_t SMLport;
 };
 
@@ -297,5 +302,6 @@
          */
         Parameter *GetSolution(Observable *observables, Parameter *currentParameters);
-        Parameter *GetSolution(Observable *observables, Parameter *currentParameters, std::string service);
+        Parameter *GetSolution(Observable *observables, Parameter *currentParameters, \
+                std::string service);
 
         /* Receive a feedback from the radio regarding the performance of a
@@ -380,9 +386,9 @@
         void DeregisterSML(int32_t socketFD);
         
-	void SetActiveMission(int32_t socketFD);
+	    void SetActiveMission(int32_t socketFD);
 
         /* Handle a message that is received from a component.
          */
-        int HandleMessage(int32_t socketFD);
+        int32_t HandleMessage(int32_t socketFD);
        
         /* Send optimization request to primary port FD.
@@ -390,25 +396,43 @@
         void GetOptimalParameters(int32_t socketFD);
 
+        /* TODO
+         */
         bool SendRadioConfiguration(int32_t socketFD);
         bool SendRadioExperience(int32_t socketFD);
 
+        /* TODO
+         */
 		bool UpdateParameterPerformance(int32_t socketFD);
 
+        /* TODO
+         */
         bool SML_present;
         bool PE_present;
         bool CE_present;
        
+        /* TODO
+         */
         int32_t numberOfCognitiveEngines; 
+
+        /* TODO
+         */       
         int16_t primaryPort;
         int16_t policyPort;
         int16_t commandPort;
 
+        /* TODO
+         */
         int32_t ceSocketFD;
         int32_t commandSocketFD;
         int32_t policySocketFD;
 
+        /* TODO
+         */
         Utility *utils;
         Parameter *params;
         Observable *observables;
+
+        /* TODO
+         */
         struct Radio_Info *radio_info;
 };